(function( $ ) {
$.widget( "descartes_editor.descartesPropEditorPane", {
	version: "1.10.3",
	// default options
	options : {
		icons: {
			down	: "ui-icon-triangle-1-s",
			up		: "ui-icon-triangle-1-n",
			remove 	: 'ui-icon-trash',
			create	: 'ui-icon-document' ,
			copy	: 'ui-icon-copy',	
			code	: 'ui-icon-circle-arrow-s',	
		},
		editorPane:null,
		structure : [],
		babel : descartes.editor.ui_config.babel,
	},
	
	setObject:function (obj,type){
		try{
			var wrapLabel = descartes.editor.ui_config.utils.getWrapperTraductorLabel();
			var traductor = descartes.editor.ui_config.babel.t; 
			var tmpTable = $('<table>');
			var cfgPExist = false;
			var paneCfg = {};
			try{
				paneCfg = descartes.editor.ui_config.getCfgFor(type);
				cfgPExist = true;
			} catch(e){ }
			var sTypes = type.join(",");
			
			if(!cfgPExist)
				alert(traductor('The configuration for the element type [%type] don\'t exist',{'%type':sTypes}));
					
			// We wan't to keep unknow properties, for future extension of editor :)
			var pCfgExt = $.extend({},paneCfg,obj);
			for ( var fieldName in pCfgExt) {
				var fieldCfg = {};
				var fieldLabel = null;
				var fieldValue = null;
				if(paneCfg.hasOwnProperty(fieldName)){
					fieldCfg		= paneCfg[fieldName];
					fieldCfg.value	= (fieldCfg.hasOwnProperty('value'))?fieldCfg.value:''; 
					
					fieldLabel	= (fieldCfg.label)?fieldCfg.label:fieldName; 
					
					fieldValue	= (obj.hasOwnProperty(fieldName)) && ($.trim(obj[fieldName].toString()) != ''); 
					fieldValue	= (fieldValue)?obj[fieldName]:fieldCfg.value;
				} else {
					fieldLabel = fieldName;
					fieldValue = obj[fieldName];
				}
				fieldLabel = $(wrapLabel).text(fieldLabel);
				var tmpTr = $("<tr>")
								.append($('<td>').append(fieldLabel))
								.appendTo(tmpTable);
				var widget = this._getWidgetFor(obj,fieldName,fieldCfg);
				$("<td>").append(widget).appendTo(tmpTr);
			}
			
			this.element.html('');
			this.element.append(tmpTable);
			
		}catch(e){
			console.log(e);
			alert('No existe la configuración\n'+e.toLocaleString()+". LINE : "+e.line);
		}
		
	},
	/**
	 * 
	 */
	update: function (){
		var elements = $('.descartes-editor-field-wrapper',this.element); 
		elements.each(function(idx,element){
			var input = element.input;
			var cfgOrig = element.objectCfg;
			var fieldKey = element.fieldKey;
			var value = cfgOrig[fieldKey]; 
			input.val(value);
		});
	},
	
	
	
	
	// the constructor
	_create : function() {		
	},
	// events bound via _on are removed automatically
	// revert other modifications here
	_destroy : function() {
		// remove generated elements
		this.btnAdd.remove();
		this.element.removeClass("custom-colorize")
				.enableSelection().css("background-color",
						"transparent");
	},
	_setOptions : function() {
		this._superApply(arguments);
		this._refresh();
	},
	_setOption : function(key, value) {
		this._super(key, value);
	},
	
	
	
	_getWidgetFor : function (objToBind,fieldName,objWidgetCfg){
		var input		= $('<input>');
		input.val(objToBind[fieldName]);
		var btnEditAux	= this._getAuxWidgetFor(input,fieldName,objToBind,objWidgetCfg);
		var wrapper		= $("<table class='input-wrapper input-wrapper-textfield'>");
		var td1 = $('<td class="wrap-input">').append(input);
		var td2 = $('<td class="aux-btn">').append(btnEditAux);
		$("<tr>").appendTo(wrapper).append(td1).append(td2);
		
		if(objWidgetCfg.hasOwnProperty('value')){
			input.attr('placeholder',objWidgetCfg['value']);
		}
		
		this._on(input,{change:function(){
			objToBind[fieldName] = input.val();
		}});
		
		wrapper.addClass("descartes-editor-field-wrapper");
		wrapper.addClass(objToBind['#superType'].join('-'));

		var wrapperHTML = wrapper[0];
		wrapperHTML.input = input;
		wrapperHTML.btnEdit = btnEditAux;
		wrapperHTML.fieldKey = fieldName;
		wrapperHTML.objectCfg = objToBind;
		
		return wrapper;
	},
	
	_getAuxWidgetFor: function(input,fieldName,objToBind,objWidgetCfg){
		return descartes.editor.ui_config.utils.getAuxWidgetFor(input,fieldName,objToBind,objWidgetCfg);
	}

});
}( jQuery ) );
